#include <iostream>
using namespace std;
int main()
{
    int n;
    cin>>n;
    int a[n-1], b[n-1], c[n-1], duz=2, l=2, j, br=1;
    bool promena=false;
    for (int i=1; i<n; i++)
        c[i]=0;
    for (int i=1; i<n; i++)
    {
        cin>>a[i]>>b[i];
    }
    for (int i=1; i<n; i++)
        {
            c[a[i]]++;
            c[b[i]]++;
        }
    for (int i=1; i<n; i++)
    {
        int p=i;
        promena=false;
        for (j=i+br; j<n; j++)
        {
            if (b[p]==a[j])
            {
                duz++;
                p=j;
            }
            else
            {
                promena=true;
                if (duz>l)
                    l=duz;
                    if (j==n-1)
                        {
                            br++;
                            j=i+br;
                            if (j>n-1)
                            {
                                br=1;
                                break;
                            }
                        }
                duz=2;
            }
        }
        if (promena==false)
        {
            if (l<duz)
                l=duz;
            duz=2;
        }
    }
    cout<<(l-1)/2;
}